image: node:latest

cache:
  paths:
    - node_modules/

stages:
  - qa
  - build
  - deploy

lint:
  stage: qa
  script:
    - npm install
    - npm run lint

test:
  stage: qa
  script:
    - npm install
    - npm run test

build:
  stage: build
  script:
    - npm run build
    - npm pack

pages:
  stage: deploy
  script:
    - npm install
    - rm -rf public docs coverage
    - npm run docs
    - npm run test
    - echo "console.log(require('./package.json').description)" | node # do something with this
    - mkdir public || true
    - mkdir public/coverage || true
    - rm coverage/tmp || true
    - mv docs/ public/
    - mv coverage/ public/coverage/
  artifacts:
    paths:
      - public
  only:
    - master
